<script lang="ts" setup>
import { ref, computed, toRefs } from 'vue';
import { ChevronLgRight } from 'slippers-ui/icons';

const { isMobile } = useCheckIfMobile();

interface Accordion {
  title: string;
  text?: string;
}

const props = defineProps({
  data: {
    type: Object as () => Accordion,
    required: true,
    default: () => ({}),
  },
  isDesktopAccordion: {
    type: Boolean,
    required: false,
    default: false,
  },
  openByDefault: {
    type: Boolean,
    required: false,
    default: false,
  },
  backgroundColor: {
    type: String,
    required: false,
    default: '#ffffff',
  },
  mobileOnly: {
    type: Boolean,
    required: false,
    default: false,
  },
});

const { openByDefault, data, mobileOnly, backgroundColor } = toRefs(props);

const isExpanded = ref(openByDefault.value);
const elementId = computed(() => `${data.value.title}-${Math.random()}`);

const toggleAccordion = () => {
  isExpanded.value = !isExpanded.value;
};
</script>

<template>
  <div :class="`survey-accordion ${mobileOnly ? 'mobile-only' : ''}`" :style="{ backgroundColor }">
    <div v-if="isMobile || isDesktopAccordion">
      <button
        :id="`${elementId}-control`"
        :aria-controls="`${elementId}-content`"
        :class="`header ${isExpanded ? 'expanded' : ''}`"
        :aria-expanded="isExpanded"
        @click="toggleAccordion"
      >
        {{ data.title }}
        <SlpIcon :icon="ChevronLgRight" hex-color="#232150" />
      </button>
      <div v-show="isExpanded" :id="data.title" class="content" role="region" :aria-labelledby="`${elementId}-control`">
        <div v-if="data.text" class="text" v-html="$md.render(data.text)"></div>
        <slot></slot>
      </div>
    </div>
    <div v-else>
      <div class="header">
        <p>{{ data.title }}</p>
      </div>
      <div class="content">
        <div v-if="data.text" class="text" v-html="$md.render(data.text)"></div>
        <slot></slot>
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.survey-accordion {
  color: #232150;
  border-radius: 8px;
  box-shadow: 0px 1px 4px 0px rgba(0, 0, 0, 0.1);
  @media (max-width: $breakpoint-md) {
    padding: 16px;
    overflow-x: scroll;
  }

  &.mobile-only {
    @media (min-width: $breakpoint-md) {
      display: none;
    }
  }

  .header {
    display: flex;
    align-items: center;
    color: #232150;
    justify-content: space-between;
    font-size: 18px;
    font-weight: 700;
    outline: none;
    border: none;
    width: 100%;
    text-align: left;
    padding: 24px;

    &:focus-visible {
      text-decoration: underline;
      text-decoration-color: #232150;
    }

    @media (max-width: $breakpoint-md) {
      padding: 0;
      font-size: 14px;
    }

    .slp-icon {
      transform: rotate(90deg);
    }

    &.expanded .slp-icon {
      transform: rotate(270deg);
    }

    .slp-icon {
      transition: transform 0.2s ease-in-out;
    }

    &:is(button) {
      cursor: pointer;
    }
  }

  .content {
    font-size: 14px;
    line-height: 22px;
    padding: 0px 24px 24px 24px;

    @media (max-width: $breakpoint-md) {
      padding: 24px 0 0 0;
    }

    .text:deep(p) {
      display: block;
      margin-bottom: 16px;

      &:last-of-type {
        margin-bottom: 0;
      }
    }

    .text:deep(ul),
    .text:deep(ol) {
      padding-left: 1.5rem;
    }

    .text:deep(li) {
      list-style-type: disc;
      margin-bottom: 8px;
    }

    .text:deep(h2),
    .text:deep(h3) {
      font-size: 14px;
      font-style: normal;
      font-weight: 600;
      line-height: 22px;

      .header-anchor {
        display: none;
      }
    }
  }
}
</style>
